package org.artifactory.projects;

import lombok.NonNull;
import org.artifactory.security.SimpleUser;
import org.artifactory.spring.Reloadable;
import org.jfrog.access.client.project.ProjectEntity;
import org.jfrog.access.client.project.ProjectResourceEntity;
import org.jfrog.access.client.project.ProjectSlimEntity;
import org.jfrog.access.rest.user.User;
import org.springframework.stereotype.Service;

import javax.annotation.Nullable;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author BarakH
 */
@Service
@Reloadable(beanClass = ProjectsService.class)
public class ProjectsServiceDefaultImpl implements ProjectsService {

    @Override
    public void onContextCreated() {
    }

    @Override
    @NonNull
    public List<String> getAllProjectsManagedByUser() {
        return Collections.emptyList();
    }

    @Override
    @NonNull
    public List<String> getAllProjects() {
        return Collections.emptyList();
    }

    @Override
    @NonNull
    public List<ProjectEntity> getAllProjectsEntities() {
        return Collections.emptyList();
    }

    @Override
    @NonNull
    public Set<String> getProjectRepositoriesKeys(String projectKey, boolean ignoreCache) {
        return Collections.emptySet();
    }

    @Override
    @NonNull
    public String getProjectKeyOfRepository(String repoKey) {
        return DEFAULT_PROJECT;
    }

    @Override
    @NonNull
    public String getProjectKeyOfRepositoryInternal(@Nullable String repoKey) {
        return DEFAULT_PROJECT;
    }

    @Override
    @NonNull
    public String getProjectDisplayName(String projectKey) {
        return DEFAULT_PROJECT;
    }

    @Override
    @NonNull
    public Map<String, String> getRepoKeyToProjectMap(@NonNull Set<String> repositories, boolean ignoreCache) {
        return Map.of();
    }

    @Override
    @Nullable
    public ProjectResourceEntity getProjectRepositoryEntity(@NonNull String projectKey, @NonNull String repoKey) {
        return null;
    }

    @Override
    public long getProjectStorageQuotaBytes(String projectKey) {
        return UNLIMITED_STORAGE;
    }

    public ProjectSlimEntity getProjectSpec(String projectKey) {
        return null;
    }

    @Override
    @NonNull
    public Map<String, Map<String, ProjectResourceEntity>> getAllProjectsRepositoriesMap(boolean ignoreCache) {
        return Map.of();
    }

    @Override
    @NonNull
    public Map<String, ProjectResourceEntity> getProjectRepositoriesMap(@NonNull String projectKey,
            boolean ignoreCache) {
        return Map.of();
    }

    @Override
    public boolean isProjectAdmin(@Nullable String projectKey, @NonNull SimpleUser user) {
        return false;
    }

    @Override
    public boolean canManageProjectResources(@Nullable String projectKey, @NonNull SimpleUser user) {
        return false;
    }

    @Override
    public boolean canProjectAdminManageResources(String repoKey, @NonNull SimpleUser user) {
        return false;
    }

    @Override
    public long getProjectQuotaSizeByRepository(@NonNull String repoKey) {
        return ProjectsService.UNLIMITED_STORAGE;
    }

    @Override
    @NonNull
    public Set<User> getProjectAdmins(@NonNull ProjectEntity projectKey) {
        return Set.of();
    }
}
